Index: uspace/srv/audio/hound/audio_sink.c
===================================================================
--- uspace/srv/audio/hound/audio_sink.c	(revision eda4323867bf5a8e98aa598c3cca1e3fb59f4e7a)
+++ uspace/srv/audio/hound/audio_sink.c	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -36,4 +36,5 @@
 #include <assert.h>
 #include <errno.h>
+#include <fibril_synch.h>
 #include <stdlib.h>
 #include <str.h>
@@ -64,4 +65,5 @@
 		return EINVAL;
 	link_initialize(&sink->link);
+	fibril_mutex_initialize(&sink->lock);
 	list_initialize(&sink->connections);
 	sink->name = str_dup(name);
@@ -139,4 +141,5 @@
 
 	pcm_format_silence(dest, size, &sink->format);
+	fibril_mutex_lock(&sink->lock);
 	list_foreach(sink->connections, sink_link, connection_t, conn) {
 		const errno_t ret = connection_add_source_data(
@@ -147,4 +150,5 @@
 		}
 	}
+	fibril_mutex_unlock(&sink->lock);
 }
 
Index: uspace/srv/audio/hound/audio_sink.h
===================================================================
--- uspace/srv/audio/hound/audio_sink.h	(revision eda4323867bf5a8e98aa598c3cca1e3fb59f4e7a)
+++ uspace/srv/audio/hound/audio_sink.h	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -41,4 +41,5 @@
 #include <stdbool.h>
 #include <fibril.h>
+#include <fibril_synch.h>
 #include <pcm/format.h>
 
@@ -51,4 +52,6 @@
 	/** Link in hound's sink list */
 	link_t link;
+	/** Protect sink including list of connections */
+	fibril_mutex_t lock;
 	/** List of all related connections */
 	list_t connections;
Index: uspace/srv/audio/hound/connection.c
===================================================================
--- uspace/srv/audio/hound/connection.c	(revision eda4323867bf5a8e98aa598c3cca1e3fb59f4e7a)
+++ uspace/srv/audio/hound/connection.c	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -61,5 +61,7 @@
 		conn->source = source;
 		list_append(&conn->source_link, &source->connections);
+		fibril_mutex_lock(&sink->lock);
 		list_append(&conn->sink_link, &sink->connections);
+		fibril_mutex_unlock(&sink->lock);
 		audio_sink_set_format(sink, audio_source_format(source));
 		if (source->connection_change)
@@ -83,5 +85,7 @@
 	assert(!link_in_use(&connection->hound_link));
 	list_remove(&connection->source_link);
+	fibril_mutex_lock(&connection->sink->lock);
 	list_remove(&connection->sink_link);
+	fibril_mutex_unlock(&connection->sink->lock);
 	if (connection->sink && connection->sink->connection_change)
 		connection->sink->connection_change(connection->sink, false);
Index: uspace/srv/audio/hound/hound.c
===================================================================
--- uspace/srv/audio/hound/hound.c	(revision eda4323867bf5a8e98aa598c3cca1e3fb59f4e7a)
+++ uspace/srv/audio/hound/hound.c	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -126,4 +126,5 @@
 	assert(fibril_mutex_is_locked(&hound->list_guard));
 	log_verbose("Removing sink '%s'.", sink->name);
+	fibril_mutex_lock(&sink->lock);
 	if (!list_empty(&sink->connections))
 		log_warning("Removing sink '%s' while still connected.", sink->name);
@@ -135,4 +136,5 @@
 	}
 	list_remove(&sink->link);
+	fibril_mutex_unlock(&sink->lock);
 }
 
Index: uspace/srv/hid/console/console.c
===================================================================
--- uspace/srv/hid/console/console.c	(revision eda4323867bf5a8e98aa598c3cca1e3fb59f4e7a)
+++ uspace/srv/hid/console/console.c	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2022 Jiri Svoboda
  * Copyright (c) 2011 Martin Decky
  * All rights reserved.
@@ -120,9 +120,11 @@
 static errno_t input_ev_active(input_t *);
 static errno_t input_ev_deactive(input_t *);
-static errno_t input_ev_key(input_t *, kbd_event_type_t, keycode_t, keymod_t, char32_t);
-static errno_t input_ev_move(input_t *, int, int);
-static errno_t input_ev_abs_move(input_t *, unsigned, unsigned, unsigned, unsigned);
-static errno_t input_ev_button(input_t *, int, int);
-static errno_t input_ev_dclick(input_t *, int);
+static errno_t input_ev_key(input_t *, unsigned, kbd_event_type_t, keycode_t,
+    keymod_t, char32_t);
+static errno_t input_ev_move(input_t *, unsigned, int, int);
+static errno_t input_ev_abs_move(input_t *, unsigned, unsigned, unsigned,
+    unsigned, unsigned);
+static errno_t input_ev_button(input_t *, unsigned, int, int);
+static errno_t input_ev_dclick(input_t *, unsigned, int);
 
 static input_ev_ops_t input_ev_ops = {
@@ -357,6 +359,6 @@
 }
 
-static errno_t input_ev_key(input_t *input, kbd_event_type_t type, keycode_t key,
-    keymod_t mods, char32_t c)
+static errno_t input_ev_key(input_t *input, unsigned kbd_id,
+    kbd_event_type_t type, keycode_t key, keymod_t mods, char32_t c)
 {
 	cons_event_t event;
@@ -369,4 +371,5 @@
 		event.type = CEV_KEY;
 
+		(void)kbd_id;
 		event.ev.key.type = type;
 		event.ev.key.key = key;
@@ -417,20 +420,25 @@
 }
 
-static errno_t input_ev_move(input_t *input, int dx, int dy)
-{
+static errno_t input_ev_move(input_t *input, unsigned pos_id, int dx, int dy)
+{
+	(void) pos_id;
 	pointer_update(pointer_x + dx, pointer_y + dy);
 	return EOK;
 }
 
-static errno_t input_ev_abs_move(input_t *input, unsigned x, unsigned y,
-    unsigned max_x, unsigned max_y)
-{
+static errno_t input_ev_abs_move(input_t *input, unsigned pos_id, unsigned x,
+    unsigned y, unsigned max_x, unsigned max_y)
+{
+	(void)pos_id;
 	pointer_update(mouse_scale_x * cols * x / max_x, mouse_scale_y * rows * y / max_y);
 	return EOK;
 }
 
-static errno_t input_ev_button(input_t *input, int bnum, int bpress)
+static errno_t input_ev_button(input_t *input, unsigned pos_id, int bnum,
+    int bpress)
 {
 	cons_event_t event;
+
+	(void)pos_id;
 
 	event.type = CEV_POS;
@@ -444,7 +452,9 @@
 }
 
-static errno_t input_ev_dclick(input_t *input, int bnum)
+static errno_t input_ev_dclick(input_t *input, unsigned pos_id, int bnum)
 {
 	cons_event_t event;
+
+	(void)pos_id;
 
 	event.type = CEV_POS;
Index: uspace/srv/hid/display/client.c
===================================================================
--- uspace/srv/hid/display/client.c	(revision eda4323867bf5a8e98aa598c3cca1e3fb59f4e7a)
+++ uspace/srv/hid/display/client.c	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -181,5 +181,5 @@
  * @param ewindow Place to store pointer to window receiving the event
  * @param event Place to store event
- * @return Graphic context
+ * @return EOK on success, ENOENT if event queue is empty
  */
 errno_t ds_client_get_event(ds_client_t *client, ds_window_t **ewindow,
Index: uspace/srv/hid/display/display.c
===================================================================
--- uspace/srv/hid/display/display.c	(revision eda4323867bf5a8e98aa598c3cca1e3fb59f4e7a)
+++ uspace/srv/hid/display/display.c	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2022 Jiri Svoboda
  * All rights reserved.
  *
@@ -45,7 +45,8 @@
 #include "cursimg.h"
 #include "cursor.h"
+#include "display.h"
 #include "seat.h"
 #include "window.h"
-#include "display.h"
+#include "wmclient.h"
 
 static gfx_context_t *ds_display_get_unbuf_gc(ds_display_t *);
@@ -96,4 +97,5 @@
 	fibril_mutex_initialize(&disp->lock);
 	list_initialize(&disp->clients);
+	list_initialize(&disp->wmclients);
 	disp->next_wnd_id = 1;
 	list_initialize(&disp->ddevs);
@@ -114,7 +116,19 @@
 void ds_display_destroy(ds_display_t *disp)
 {
+	int i;
+
 	assert(list_empty(&disp->clients));
+	assert(list_empty(&disp->wmclients));
 	assert(list_empty(&disp->seats));
-	/* XXX destroy cursors */
+	assert(list_empty(&disp->ddevs));
+	assert(list_empty(&disp->seats));
+	assert(list_empty(&disp->windows));
+
+	/* Destroy cursors */
+	for (i = 0; i < dcurs_limit; i++) {
+		ds_cursor_destroy(disp->cursor[i]);
+		disp->cursor[i] = NULL;
+	}
+
 	gfx_color_delete(disp->bg_color);
 	free(disp);
@@ -203,4 +217,59 @@
 
 	return list_get_instance(link, ds_client_t, lclients);
+}
+
+/** Add WM client to display.
+ *
+ * @param disp Display
+ * @param wmclient WM client
+ */
+void ds_display_add_wmclient(ds_display_t *disp, ds_wmclient_t *wmclient)
+{
+	assert(wmclient->display == NULL);
+	assert(!link_used(&wmclient->lwmclients));
+
+	wmclient->display = disp;
+	list_append(&wmclient->lwmclients, &disp->wmclients);
+}
+
+/** Remove WM client from display.
+ *
+ * @param wmclient WM client
+ */
+void ds_display_remove_wmclient(ds_wmclient_t *wmclient)
+{
+	list_remove(&wmclient->lwmclients);
+	wmclient->display = NULL;
+}
+
+/** Get first WM client in display.
+ *
+ * @param disp Display
+ * @return First WM client or @c NULL if there is none
+ */
+ds_wmclient_t *ds_display_first_wmclient(ds_display_t *disp)
+{
+	link_t *link = list_first(&disp->wmclients);
+
+	if (link == NULL)
+		return NULL;
+
+	return list_get_instance(link, ds_wmclient_t, lwmclients);
+}
+
+/** Get next WM client in display.
+ *
+ * @param wmclient Current WM client
+ * @return Next WM client or @c NULL if there is none
+ */
+ds_wmclient_t *ds_display_next_wmclient(ds_wmclient_t *wmclient)
+{
+	link_t *link = list_next(&wmclient->lwmclients,
+	    &wmclient->display->wmclients);
+
+	if (link == NULL)
+		return NULL;
+
+	return list_get_instance(link, ds_wmclient_t, lwmclients);
 }
 
@@ -246,5 +315,6 @@
 		gfx_rect_translate(&wnd->dpos, &wnd->rect, &drect);
 
-		if (gfx_pix_inside_rect(pos, &drect))
+		if (gfx_pix_inside_rect(pos, &drect) &&
+		    ds_window_is_visible(wnd))
 			return wnd;
 
@@ -255,4 +325,36 @@
 }
 
+/** Add window to window list.
+ *
+ * Topmost windows are enlisted before any other window. Non-topmost
+ * windows are enlisted before any other non-topmost window.
+ *
+ * @param display Display
+ * @param wnd Window
+ */
+void ds_display_enlist_window(ds_display_t *display, ds_window_t *wnd)
+{
+	ds_window_t *w;
+
+	assert(wnd->display == display);
+	assert(!link_used(&wnd->ldwindows));
+
+	if ((wnd->flags & wndf_topmost) == 0) {
+		/* Find the first non-topmost window */
+		w = ds_display_first_window(display);
+		while (w != NULL && (w->flags & wndf_topmost) != 0)
+			w = ds_display_next_window(w);
+
+		if (w != NULL)
+			list_insert_before(&wnd->ldwindows, &w->ldwindows);
+		else
+			list_append(&wnd->ldwindows, &display->windows);
+	} else {
+		/* Insert at the beginning */
+		list_prepend(&wnd->ldwindows, &display->windows);
+	}
+
+}
+
 /** Add window to display.
  *
@@ -262,9 +364,18 @@
 void ds_display_add_window(ds_display_t *display, ds_window_t *wnd)
 {
+	ds_wmclient_t *wmclient;
+
 	assert(wnd->display == NULL);
 	assert(!link_used(&wnd->ldwindows));
 
 	wnd->display = display;
-	list_prepend(&wnd->ldwindows, &display->windows);
+	ds_display_enlist_window(display, wnd);
+
+	/* Notify window managers about the new window */
+	wmclient = ds_display_first_wmclient(display);
+	while (wmclient != NULL) {
+		ds_wmclient_post_wnd_added_event(wmclient, wnd->id);
+		wmclient = ds_display_next_wmclient(wmclient);
+	}
 }
 
@@ -275,6 +386,32 @@
 void ds_display_remove_window(ds_window_t *wnd)
 {
+	ds_wmclient_t *wmclient;
+	ds_display_t *display;
+
+	display = wnd->display;
+
 	list_remove(&wnd->ldwindows);
 	wnd->display = NULL;
+
+	/* Notify window managers about the removed window */
+	wmclient = ds_display_first_wmclient(display);
+	while (wmclient != NULL) {
+		ds_wmclient_post_wnd_removed_event(wmclient, wnd->id);
+		wmclient = ds_display_next_wmclient(wmclient);
+	}
+}
+
+/** Move window to top.
+ *
+ * @param display Display
+ * @param wnd Window
+ */
+void ds_display_window_to_top(ds_window_t *wnd)
+{
+	assert(wnd->display != NULL);
+	assert(link_used(&wnd->ldwindows));
+
+	list_remove(&wnd->ldwindows);
+	ds_display_enlist_window(wnd->display, wnd);
 }
 
@@ -352,6 +489,6 @@
 	ds_seat_t *seat;
 
-	// TODO Determine which seat the event belongs to
-	seat = ds_display_first_seat(display);
+	/* Determine which seat the event belongs to */
+	seat = ds_display_seat_by_idev(display, event->kbd_id);
 	if (seat == NULL)
 		return EOK;
@@ -369,6 +506,6 @@
 	ds_seat_t *seat;
 
-	// TODO Determine which seat the event belongs to
-	seat = ds_display_first_seat(display);
+	/* Determine which seat the event belongs to */
+	seat = ds_display_seat_by_idev(display, event->pos_id);
 	if (seat == NULL)
 		return EOK;
@@ -429,4 +566,18 @@
 
 	return list_get_instance(link, ds_seat_t, lseats);
+}
+
+/** Get seat which owns the specified input device.
+ *
+ * @param disp Display
+ * @param idev_id Input device ID
+ * @return Seat which owns device with ID @a idev_id or @c NULL if not found
+ */
+ds_seat_t *ds_display_seat_by_idev(ds_display_t *disp, ds_idev_id_t idev_id)
+{
+	// TODO Multi-seat
+	(void) idev_id;
+
+	return ds_display_first_seat(disp);
 }
 
@@ -493,7 +644,10 @@
 {
 	errno_t rc;
+	gfx_rect_t old_disp_rect;
 
 	assert(ddev->display == NULL);
 	assert(!link_used(&ddev->lddevs));
+
+	old_disp_rect = disp->rect;
 
 	ddev->display = disp;
@@ -507,14 +661,12 @@
 		/* Create cloning GC */
 		rc = ds_clonegc_create(ddev->gc, &disp->fbgc);
-		if (rc != EOK) {
-			// XXX Remove output
-			return ENOMEM;
-		}
+		if (rc != EOK)
+			goto error;
 
 		/* Allocate backbuffer */
 		rc = ds_display_alloc_backbuf(disp);
 		if (rc != EOK) {
-			// XXX Remove output
-			// XXX Delete clone GC
+			ds_clonegc_delete(disp->fbgc);
+			disp->fbgc = NULL;
 			goto error;
 		}
@@ -526,10 +678,9 @@
 	}
 
+	ds_display_update_max_rect(disp);
+
 	return EOK;
 error:
-	disp->rect.p0.x = 0;
-	disp->rect.p0.y = 0;
-	disp->rect.p1.x = 0;
-	disp->rect.p1.y = 0;
+	disp->rect = old_disp_rect;
 	list_remove(&ddev->lddevs);
 	return rc;
@@ -598,4 +749,69 @@
 	list_remove(&cursor->ldisplay);
 	cursor->display = NULL;
+}
+
+/** Update display maximize rectangle.
+ *
+ * Recalculate the maximize rectangle (the rectangle used for maximized
+ * windows).
+ *
+ * @param display Display
+ */
+void ds_display_update_max_rect(ds_display_t *display)
+{
+	ds_window_t *wnd;
+	gfx_rect_t max_rect;
+	gfx_rect_t drect;
+
+	/* Start with the entire display */
+	max_rect = display->rect;
+
+	wnd = ds_display_first_window(display);
+	while (wnd != NULL) {
+		/* Should maximized windows avoid this window? */
+		if ((wnd->flags & wndf_avoid) != 0) {
+			/* Window bounding rectangle on display */
+			gfx_rect_translate(&wnd->dpos, &wnd->rect, &drect);
+
+			/* Crop maximized rectangle */
+			ds_display_crop_max_rect(&drect, &max_rect);
+		}
+
+		wnd = ds_display_next_window(wnd);
+	}
+
+	/* Update the maximize rectangle */
+	display->max_rect = max_rect;
+}
+
+/** Crop maximize rectangle.
+ *
+ * Use the avoid rectangle @a arect to crop off maximization rectangle
+ * @a mrect. If @a arect covers the top, bottom, left or right part
+ * of @a mrect, it will be cropped off. Otherwise there will be
+ * no effect.
+ *
+ * @param arect Avoid rectangle
+ * @param mrect Maximize rectangle to be modified
+ */
+void ds_display_crop_max_rect(gfx_rect_t *arect, gfx_rect_t *mrect)
+{
+	if (arect->p0.x == mrect->p0.x && arect->p0.y == mrect->p0.y &&
+	    arect->p1.x == mrect->p1.x) {
+		/* Cropp off top part */
+		mrect->p0.y = arect->p1.y;
+	} else if (arect->p0.x == mrect->p0.x && arect->p1.x == mrect->p1.x &&
+	    arect->p1.y == mrect->p1.y) {
+		/* Cropp off bottom part */
+		mrect->p1.y = arect->p0.y;
+	} else if (arect->p0.x == mrect->p0.x && arect->p0.y == mrect->p0.y &&
+	    arect->p1.y == mrect->p1.y) {
+		/* Cropp off left part */
+		mrect->p0.x = arect->p1.x;
+	} else if (arect->p0.y == mrect->p0.y && arect->p1.x == mrect->p1.x &&
+	    arect->p1.y == mrect->p1.y) {
+		/* Cropp off right part */
+		mrect->p1.x = arect->p0.x;
+	}
 }
 
Index: uspace/srv/hid/display/display.h
===================================================================
--- uspace/srv/hid/display/display.h	(revision eda4323867bf5a8e98aa598c3cca1e3fb59f4e7a)
+++ uspace/srv/hid/display/display.h	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2019 Jiri Svoboda
+ * Copyright (c) 2022 Jiri Svoboda
  * All rights reserved.
  *
@@ -46,6 +46,8 @@
 #include "types/display/ddev.h"
 #include "types/display/display.h"
+#include "types/display/idev.h"
 #include "types/display/ptd_event.h"
 #include "types/display/seat.h"
+#include "types/display/wmclient.h"
 
 extern errno_t ds_display_create(gfx_context_t *, ds_display_flags_t,
@@ -59,8 +61,14 @@
 extern ds_client_t *ds_display_first_client(ds_display_t *);
 extern ds_client_t *ds_display_next_client(ds_client_t *);
+extern void ds_display_add_wmclient(ds_display_t *, ds_wmclient_t *);
+extern void ds_display_remove_wmclient(ds_wmclient_t *);
+extern ds_wmclient_t *ds_display_first_wmclient(ds_display_t *);
+extern ds_wmclient_t *ds_display_next_wmclient(ds_wmclient_t *);
 extern ds_window_t *ds_display_find_window(ds_display_t *, ds_wnd_id_t);
 extern ds_window_t *ds_display_window_by_pos(ds_display_t *, gfx_coord2_t *);
+extern void ds_display_enlist_window(ds_display_t *, ds_window_t *);
 extern void ds_display_add_window(ds_display_t *, ds_window_t *);
 extern void ds_display_remove_window(ds_window_t *);
+extern void ds_display_window_to_top(ds_window_t *);
 extern ds_window_t *ds_display_first_window(ds_display_t *);
 extern ds_window_t *ds_display_last_window(ds_display_t *);
@@ -73,4 +81,5 @@
 extern ds_seat_t *ds_display_first_seat(ds_display_t *);
 extern ds_seat_t *ds_display_next_seat(ds_seat_t *);
+extern ds_seat_t *ds_display_seat_by_idev(ds_display_t *, ds_idev_id_t);
 extern errno_t ds_display_add_ddev(ds_display_t *, ds_ddev_t *);
 extern void ds_display_remove_ddev(ds_ddev_t *);
@@ -79,4 +88,6 @@
 extern void ds_display_add_cursor(ds_display_t *, ds_cursor_t *);
 extern void ds_display_remove_cursor(ds_cursor_t *);
+extern void ds_display_update_max_rect(ds_display_t *);
+extern void ds_display_crop_max_rect(gfx_rect_t *, gfx_rect_t *);
 extern gfx_context_t *ds_display_get_gc(ds_display_t *);
 extern errno_t ds_display_paint_bg(ds_display_t *, gfx_rect_t *);
Index: uspace/srv/hid/display/dsops.c
===================================================================
--- uspace/srv/hid/display/dsops.c	(revision eda4323867bf5a8e98aa598c3cca1e3fb59f4e7a)
+++ uspace/srv/hid/display/dsops.c	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -54,7 +54,9 @@
 static errno_t disp_window_resize(void *, sysarg_t, gfx_coord2_t *,
     gfx_rect_t *);
+static errno_t disp_window_minimize(void *, sysarg_t);
 static errno_t disp_window_maximize(void *, sysarg_t);
 static errno_t disp_window_unmaximize(void *, sysarg_t);
 static errno_t disp_window_set_cursor(void *, sysarg_t, display_stock_cursor_t);
+static errno_t disp_window_set_caption(void *, sysarg_t, const char *);
 static errno_t disp_get_event(void *, sysarg_t *, display_wnd_ev_t *);
 static errno_t disp_get_info(void *, display_info_t *);
@@ -69,7 +71,9 @@
 	.window_resize_req = disp_window_resize_req,
 	.window_resize = disp_window_resize,
+	.window_minimize = disp_window_minimize,
 	.window_maximize = disp_window_maximize,
 	.window_unmaximize = disp_window_unmaximize,
 	.window_set_cursor = disp_window_set_cursor,
+	.window_set_caption = disp_window_set_caption,
 	.get_event = disp_get_event,
 	.get_info = disp_get_info
@@ -245,4 +249,24 @@
 }
 
+static errno_t disp_window_minimize(void *arg, sysarg_t wnd_id)
+{
+	ds_client_t *client = (ds_client_t *) arg;
+	ds_window_t *wnd;
+	errno_t rc;
+
+	ds_display_lock(client->display);
+
+	wnd = ds_client_find_window(client, wnd_id);
+	if (wnd == NULL) {
+		ds_display_unlock(client->display);
+		return ENOENT;
+	}
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "disp_window_maximize()");
+	rc = ds_window_minimize(wnd);
+	ds_display_unlock(client->display);
+	return rc;
+}
+
 static errno_t disp_window_maximize(void *arg, sysarg_t wnd_id)
 {
@@ -306,4 +330,25 @@
 }
 
+static errno_t disp_window_set_caption(void *arg, sysarg_t wnd_id,
+    const char *caption)
+{
+	ds_client_t *client = (ds_client_t *) arg;
+	ds_window_t *wnd;
+	errno_t rc;
+
+	ds_display_lock(client->display);
+
+	wnd = ds_client_find_window(client, wnd_id);
+	if (wnd == NULL) {
+		ds_display_unlock(client->display);
+		return ENOENT;
+	}
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "disp_window_set_caption()");
+	rc = ds_window_set_caption(wnd, caption);
+	ds_display_unlock(client->display);
+	return rc;
+}
+
 static errno_t disp_get_event(void *arg, sysarg_t *wnd_id,
     display_wnd_ev_t *event)
@@ -313,5 +358,5 @@
 	errno_t rc;
 
-	log_msg(LOG_DEFAULT, LVL_DEBUG, "disp_window_get_event()");
+	log_msg(LOG_DEFAULT, LVL_DEBUG2, "disp_window_get_event()");
 
 	ds_display_lock(client->display);
Index: uspace/srv/hid/display/input.c
===================================================================
--- uspace/srv/hid/display/input.c	(revision eda4323867bf5a8e98aa598c3cca1e3fb59f4e7a)
+++ uspace/srv/hid/display/input.c	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2022 Jiri Svoboda
  * All rights reserved.
  *
@@ -45,9 +45,11 @@
 static errno_t ds_input_ev_active(input_t *);
 static errno_t ds_input_ev_deactive(input_t *);
-static errno_t ds_input_ev_key(input_t *, kbd_event_type_t, keycode_t, keymod_t, char32_t);
-static errno_t ds_input_ev_move(input_t *, int, int);
-static errno_t ds_input_ev_abs_move(input_t *, unsigned, unsigned, unsigned, unsigned);
-static errno_t ds_input_ev_button(input_t *, int, int);
-static errno_t ds_input_ev_dclick(input_t *, int);
+static errno_t ds_input_ev_key(input_t *, unsigned, kbd_event_type_t, keycode_t,
+    keymod_t, char32_t);
+static errno_t ds_input_ev_move(input_t *, unsigned, int, int);
+static errno_t ds_input_ev_abs_move(input_t *, unsigned, unsigned, unsigned,
+    unsigned, unsigned);
+static errno_t ds_input_ev_button(input_t *, unsigned, int, int);
+static errno_t ds_input_ev_dclick(input_t *, unsigned, int);
 
 static input_ev_ops_t ds_input_ev_ops = {
@@ -71,6 +73,6 @@
 }
 
-static errno_t ds_input_ev_key(input_t *input, kbd_event_type_t type,
-    keycode_t key, keymod_t mods, char32_t c)
+static errno_t ds_input_ev_key(input_t *input, unsigned kbd_id,
+    kbd_event_type_t type, keycode_t key, keymod_t mods, char32_t c)
 {
 	ds_display_t *disp = (ds_display_t *) input->user;
@@ -78,4 +80,5 @@
 	errno_t rc;
 
+	event.kbd_id = kbd_id;
 	event.type = type;
 	event.key = key;
@@ -89,10 +92,11 @@
 }
 
-static errno_t ds_input_ev_move(input_t *input, int dx, int dy)
-{
-	ds_display_t *disp = (ds_display_t *) input->user;
-	ptd_event_t event;
-	errno_t rc;
-
+static errno_t ds_input_ev_move(input_t *input, unsigned pos_id, int dx, int dy)
+{
+	ds_display_t *disp = (ds_display_t *) input->user;
+	ptd_event_t event;
+	errno_t rc;
+
+	event.pos_id = pos_id;
 	event.type = PTD_MOVE;
 	event.dmove.x = dx;
@@ -105,11 +109,12 @@
 }
 
-static errno_t ds_input_ev_abs_move(input_t *input, unsigned x, unsigned y,
-    unsigned max_x, unsigned max_y)
-{
-	ds_display_t *disp = (ds_display_t *) input->user;
-	ptd_event_t event;
-	errno_t rc;
-
+static errno_t ds_input_ev_abs_move(input_t *input, unsigned pos_id, unsigned x,
+    unsigned y, unsigned max_x, unsigned max_y)
+{
+	ds_display_t *disp = (ds_display_t *) input->user;
+	ptd_event_t event;
+	errno_t rc;
+
+	event.pos_id = pos_id;
 	event.type = PTD_ABS_MOVE;
 	event.apos.x = x;
@@ -126,10 +131,12 @@
 }
 
-static errno_t ds_input_ev_button(input_t *input, int bnum, int bpress)
-{
-	ds_display_t *disp = (ds_display_t *) input->user;
-	ptd_event_t event;
-	errno_t rc;
-
+static errno_t ds_input_ev_button(input_t *input, unsigned pos_id, int bnum,
+    int bpress)
+{
+	ds_display_t *disp = (ds_display_t *) input->user;
+	ptd_event_t event;
+	errno_t rc;
+
+	event.pos_id = pos_id;
 	event.type = bpress ? PTD_PRESS : PTD_RELEASE;
 	event.btn_num = bnum;
@@ -143,10 +150,11 @@
 }
 
-static errno_t ds_input_ev_dclick(input_t *input, int bnum)
-{
-	ds_display_t *disp = (ds_display_t *) input->user;
-	ptd_event_t event;
-	errno_t rc;
-
+static errno_t ds_input_ev_dclick(input_t *input, unsigned pos_id, int bnum)
+{
+	ds_display_t *disp = (ds_display_t *) input->user;
+	ptd_event_t event;
+	errno_t rc;
+
+	event.pos_id = pos_id;
 	event.type = PTD_DCLICK;
 	event.btn_num = bnum;
Index: uspace/srv/hid/display/main.c
===================================================================
--- uspace/srv/hid/display/main.c	(revision eda4323867bf5a8e98aa598c3cca1e3fb59f4e7a)
+++ uspace/srv/hid/display/main.c	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2019 Jiri Svoboda
+ * Copyright (c) 2022 Jiri Svoboda
  * All rights reserved.
  *
@@ -47,4 +47,5 @@
 #include <stdio.h>
 #include <task.h>
+#include <wndmgt_srv.h>
 #include "client.h"
 #include "display.h"
@@ -55,7 +56,12 @@
 #include "seat.h"
 #include "window.h"
+#include "wmclient.h"
+#include "wmops.h"
 
 static void display_client_conn(ipc_call_t *, void *);
 static void display_client_ev_pending(void *);
+static void display_wmclient_ev_pending(void *);
+static void display_gc_conn(ipc_call_t *, void *);
+static void display_wndmgt_conn(ipc_call_t *, void *);
 
 #ifdef CONFIG_DISP_DOUBLE_BUF
@@ -76,4 +82,8 @@
 };
 
+static ds_wmclient_cb_t display_wmclient_cb = {
+	.ev_pending = display_wmclient_ev_pending
+};
+
 static void display_client_ev_pending(void *arg)
 {
@@ -81,4 +91,11 @@
 
 	display_srv_ev_pending(srv);
+}
+
+static void display_wmclient_ev_pending(void *arg)
+{
+	wndmgt_srv_t *srv = (wndmgt_srv_t *) arg;
+
+	wndmgt_srv_ev_pending(srv);
 }
 
@@ -90,4 +107,7 @@
 	ds_output_t *output = NULL;
 	gfx_context_t *gc = NULL;
+	port_id_t disp_port;
+	port_id_t gc_port;
+	port_id_t wm_port;
 	errno_t rc;
 
@@ -115,5 +135,17 @@
 		goto error;
 
-	async_set_fallback_port_handler(display_client_conn, disp);
+	rc = async_create_port(INTERFACE_DISPLAY, display_client_conn, disp,
+	    &disp_port);
+	if (rc != EOK)
+		goto error;
+
+	rc = async_create_port(INTERFACE_GC, display_gc_conn, disp, &gc_port);
+	if (rc != EOK)
+		goto error;
+
+	rc = async_create_port(INTERFACE_WNDMGT, display_wndmgt_conn, disp,
+	    &wm_port);
+	if (rc != EOK)
+		goto error;
 
 	rc = loc_server_register(NAME);
@@ -135,4 +167,7 @@
 	return EOK;
 error:
+	// XXX destroy disp_port
+	// XXX destroy gc_port
+	// XXX destroy wm_port
 #if 0
 	if (disp->input != NULL)
@@ -154,10 +189,7 @@
 {
 	display_srv_t srv;
-	sysarg_t wnd_id;
 	sysarg_t svc_id;
 	ds_client_t *client = NULL;
-	ds_window_t *wnd;
 	ds_display_t *disp = (ds_display_t *) arg;
-	gfx_context_t *gc;
 	errno_t rc;
 
@@ -166,13 +198,11 @@
 	    ipc_get_arg4(icall));
 
-	(void) icall;
-	(void) arg;
-
 	svc_id = ipc_get_arg2(icall);
-	wnd_id = ipc_get_arg3(icall);
 
 	if (svc_id != 0) {
 		/* Create client object */
+		ds_display_lock(disp);
 		rc = ds_client_create(disp, &display_client_cb, &srv, &client);
+		ds_display_unlock(disp);
 		if (rc != EOK) {
 			async_answer_0(icall, ENOMEM);
@@ -191,20 +221,65 @@
 		ds_client_destroy(client);
 		ds_display_unlock(disp);
-	} else {
-		/* Window GC connection */
-
-		wnd = ds_display_find_window(disp, wnd_id);
-		if (wnd == NULL) {
-			async_answer_0(icall, ENOENT);
-			return;
-		}
-
-		/*
-		 * XXX We need a way to make sure that the connection does
-		 * not stay active after the window had been destroyed
-		 */
-		gc = ds_window_get_ctx(wnd);
-		gc_conn(icall, gc);
-	}
+	}
+}
+
+/** Handle GC connection to display server */
+static void display_gc_conn(ipc_call_t *icall, void *arg)
+{
+	sysarg_t wnd_id;
+	ds_window_t *wnd;
+	ds_display_t *disp = (ds_display_t *) arg;
+	gfx_context_t *gc;
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "display_gc_conn arg1=%zu arg2=%zu arg3=%zu arg4=%zu.",
+	    ipc_get_arg1(icall), ipc_get_arg2(icall), ipc_get_arg3(icall),
+	    ipc_get_arg4(icall));
+
+	wnd_id = ipc_get_arg3(icall);
+
+	/* Window GC connection */
+
+	wnd = ds_display_find_window(disp, wnd_id);
+	if (wnd == NULL) {
+		async_answer_0(icall, ENOENT);
+		return;
+	}
+
+	/*
+	 * XXX We need a way to make sure that the connection does
+	 * not stay active after the window had been destroyed
+	 */
+	gc = ds_window_get_ctx(wnd);
+	gc_conn(icall, gc);
+}
+
+/** Handle window management connection to display server */
+static void display_wndmgt_conn(ipc_call_t *icall, void *arg)
+{
+	ds_display_t *disp = (ds_display_t *) arg;
+	errno_t rc;
+	wndmgt_srv_t srv;
+	ds_wmclient_t *wmclient = NULL;
+
+	/* Create WM client object */
+	ds_display_lock(disp);
+	rc = ds_wmclient_create(disp, &display_wmclient_cb, &srv, &wmclient);
+	ds_display_unlock(disp);
+	if (rc != EOK) {
+		async_answer_0(icall, ENOMEM);
+		return;
+	}
+
+	/* Set up protocol structure */
+	wndmgt_srv_initialize(&srv);
+	srv.ops = &wndmgt_srv_ops;
+	srv.arg = wmclient;
+
+	/* Handle connection */
+	wndmgt_conn(icall, &srv);
+
+	ds_display_lock(disp);
+	ds_wmclient_destroy(wmclient);
+	ds_display_unlock(disp);
 }
 
Index: uspace/srv/hid/display/meson.build
===================================================================
--- uspace/srv/hid/display/meson.build	(revision eda4323867bf5a8e98aa598c3cca1e3fb59f4e7a)
+++ uspace/srv/hid/display/meson.build	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -1,4 +1,4 @@
 #
-# Copyright (c) 2019 Jiri Svoboda
+# Copyright (c) 2022 Jiri Svoboda
 # All rights reserved.
 #
@@ -27,5 +27,5 @@
 #
 
-deps = [ 'ipcgfx', 'memgfx', 'display', 'ddev' ]
+deps = [ 'ipcgfx', 'memgfx', 'display', 'ddev', 'wndmgt' ]
 
 src = files(
@@ -42,4 +42,6 @@
 	'seat.c',
 	'window.c',
+	'wmclient.c',
+	'wmops.c',
 )
 
@@ -53,4 +55,5 @@
 	'seat.c',
 	'window.c',
+	'wmclient.c',
 	'test/client.c',
 	'test/clonegc.c',
@@ -60,3 +63,4 @@
 	'test/seat.c',
 	'test/window.c',
+	'test/wmclient.c',
 )
